#ifndef NETEX_LIST_H
#define NETEX_LIST_H


typedef enum list_iterate_states
{
    CONTINUE = 0 << 0,
    BREAK = 1 << 0,
    DELETE = 1 << 1
} iterate_state;

typedef enum list_found_states
{
    FOUND = 0,
    NOT_FOUND = 1
} found_state;

typedef struct list_node
{
    void* data;
    struct list_node* previous;
    struct list_node* next;
} list_node;



list_node* insert_node(list_node* node, void* data);
list_node* add_node(list_node* node, void* data, bool add_end);
void delete_node(list_node* node);
void iterate_list(list_node* list, bool forward, iterate_state (*iterFunc)(const void*));

#endif //NETEX_LIST_H
