#ifndef LOG_H
#define LOG_H
#include "list.h"

enum log_level
{
    Info = 0,
    Warning = 1,
    Error = 2,
    Fatal = 3,
    Debug = 4,
    Verbose = 5
};
typedef struct log_info_base
{
    char* log_file;
    char* executable_name;
    int log_file_max_size;
    enum log_level max_log_level;
    list_node* loggers;
} log_base;

typedef struct logger
{
    log_base* app_logger;
    char* name;
    void (*log_info)(const char* format, ...);
} logger;

log_base* initialize_log_base(const char* logPath, const char* executable, int max_file_size_bytes, enum log_level maxLogLevel);
void shutdown_log(log_base* base);
logger* create_logger(log_base* base, const char* name);


#endif //LOG_H
