#include "netex.h"
#include "server.h"

// Sources:
// http://simplestcodings.blogspot.com/2010/08/secure-server-client-using-openssl-in-c.html
// https://stackoverflow.com/questions/40812836/how-to-create-chat-server-using-openssl-in-c
// https://www.cs.cmu.edu/~srini/15-441/F02/Projects/lab01/reference/part1.pdf

log_base* srv_log_base;

int main(int argc, char *argv[])
{
    // Setup base logger
    srv_log_base = initialize_log_base("logs", "netex_server", 100000, Debug);
    if (srv_log_base == NULL)
    {
        ERROR("Failed to initialize internal logger!");
        return 0;
    }
    netex_init();
    if (!setup_srv_curses())
    {
        shutdown_log(srv_log_base);
        PRINT_LINE("Failed to setup srv windows! Press any key to exit.");
        getch();
        return 0;
    }
    getch(); // For debugging!
    if (initialize_server(argc, argv))
    {
        WARN("Failed to initialize server! Exiting...");
        netex_shutdown();
        shutdown_log(srv_log_base);
        return 0;
    }
    const int srv_exec_result = server_execute();
    netex_shutdown();
    int server_result = srv_exec_result;
    shutdown_log(srv_log_base);
    return server_result;
}